;**************************************************************
;	
;	This is the driver for NOR flash operation.
;
;**************************************************************


	AREA    Init, CODE, READONLY
	GET def.s
	CODE32

	ENTRY


	;//Import
	IMPORT main_func
	

	;//Switch to SVC32 mode and Disable interrupts
	MRS	r0, cpsr
	BIC	r0, r0, #MASK_MODE
	ORR	r0, r0, #MODE_SVC32
	ORR r0, r0, #I_BIT
	ORR r0, r0, #F_BIT
	MSR	cpsr_c, r0
	
	
	;//Set SP 
	MOV SP, PC
	ADD SP, SP, #0x7D0
	
	
	;//Jump to main func
	BL main_func

	
	;//Endless Loop
	B .
	
	
	END
